/***************************************************************************\
*                                                                           *
* BuilderX Version 4.0                                                      *
*                                                                           *
* Copyright (C) 1999 Xironic. All Rights Reserved.                          *
*                                                                           *
\***************************************************************************/


//---------------------------------------------------------------------------
#ifndef BX3DSceneH
#define BX3DSceneH

#include "BX3DFrame.h"

enum TFogMode{fLinear,fExponential,fExponentialSquared};

//TBX3DScene
//-----------------------------------------------------------------------------
class TBX3DScene;

class PACKAGE TBX3DFog : public TPersistent
{
  private:
    TColor FColor;
    void __fastcall SetColor(TColor);
    bool FVisible;
    void __fastcall SetVisible(bool);
    TFogMode FMode;
    void __fastcall SetMode(TFogMode);
    TFogMode __fastcall GetMode();
    float FStart;
    float FEnd;
    float FDensity;
    void __fastcall SetStart(float);
    void __fastcall SetEnd(float);
    void __fastcall SetDensity(float);
    float __fastcall GetStart();
    float __fastcall GetEnd();
    float __fastcall GetDensity();
    void __fastcall Change();
    TBX3DScene* OwnerScene;

  public:
    __fastcall TBX3DFog(TBX3DScene*);

 __published:
    __property TColor Color={read=FColor,write=SetColor};
    __property bool Visible={read=FVisible,write=SetVisible};
    __property TFogMode Mode={read=GetMode,write=SetMode};
    __property float Start={read=GetStart,write=SetStart};
    __property float End={read=GetEnd,write=SetEnd};
    __property float Density={read=GetDensity,write=SetDensity};
};

class PACKAGE TBX3DScene : public TBX3DCustomFrame
{
  private:
    TBX3DFog* FFog;
    AnsiString FBackgroundImage;
    void __fastcall SetBackgroundImage(AnsiString);
    TColor FBackgroundColor;
    void __fastcall SetBackgroundColor(TColor);
    void __fastcall Init();

  public:
    __fastcall TBX3DScene(TComponent* Owner);
    __fastcall ~TBX3DScene();

    __property IDirect3DRMFrame3;
  protected:

  __published:
    __property TBX3DFog* Fog={read=FFog,write=FFog};
    __property TColor BackgroundColor={read=FBackgroundColor,write=SetBackgroundColor};
    __property AnsiString BackgroundImage={read=FBackgroundImage,write=SetBackgroundImage};
};
//---------------------------------------------------------------------------
#endif
