/***************************************************************************\
*                                                                           *
* BuilderX Version 4.0                                                      *
*                                                                           *
* Copyright (C) 1999 Xironic. All Rights Reserved.                          *
*                                                                           *
\***************************************************************************/


//---------------------------------------------------------------------------
#ifndef BXIMouseH
#define BXIMouseH
//---------------------------------------------------------------------------
#include "dinput.h"

#include "BX3DFrame.h"

#define MMAX_BUFFER_SIZE 1024

typedef void __fastcall (__closure *TEventMouseButton)(System::TObject* Sender,DWORD TimeStamp,DWORD Sequence);
typedef void __fastcall (__closure *TEventMouseMove)(System::TObject* Sender,LONG X,LONG Y,LONG Z,DWORD TimeStamp,DWORD Sequence);

class TMouseCheckLoop;

class PACKAGE TBXIMouse:public TComponent
{
  private:

    DWORD Elements;
    DWORD PrevElements;
    DIDEVICEOBJECTDATA prevdidod[MMAX_BUFFER_SIZE];
    DIDEVICEOBJECTDATA didod[MMAX_BUFFER_SIZE];

    DWORD FBufferSize;
    void __fastcall SetBufferSize(DWORD Value);
    bool FBuffered;
    void __fastcall SetBuffered(bool Value);

    bool FBackground;
    void __fastcall SetBackground(bool Value);
    bool FExclusive;
    void __fastcall SetExclusive(bool Value);

    TMouseCheckLoop *MouseCheckLoop;
    LONG FXScreen;
    LONG FYScreen;
    LONG FX;
    LONG FY;
    LONG FZ;
    bool FButton0;
    bool FButton1;
    bool FButton2;
    bool FButton3;

    TNotifyEvent FOnChange;

    TEventMouseButton FOnButton0Down;
    TEventMouseButton FOnButton0Up;
    TEventMouseButton FOnButton1Down;
    TEventMouseButton FOnButton1Up;
    TEventMouseButton FOnButton2Down;
    TEventMouseButton FOnButton2Up;
    TEventMouseButton FOnButton3Down;
    TEventMouseButton FOnButton3Up;
    TEventMouseMove FOnMove;

    void __fastcall SetFocusControl();
    void __fastcall Activation();
    void __fastcall Deactivation();

    bool FAutoCheck;
    void __fastcall SetAutoCheck(bool);
    bool FActive;
    void __fastcall SetActive(bool);
    void __fastcall Tick(TObject*);
    void __fastcall GenEvent();
  protected:
  public:
    void __fastcall CallCheckChange();
    bool CheckChange();
    LPDIRECTINPUT  DIHandle;
    LPDIRECTINPUTDEVICE  DIDevice2;

    __fastcall TBXIMouse(TComponent* Owner);
    __fastcall ~TBXIMouse();

    __property LONG XScreen={read=FXScreen};
    __property LONG YScreen={read=FYScreen};
    __property LONG X={read=FX};
    __property LONG Y={read=FY};
    __property LONG Z={read=FZ};
    __property bool Button0={read=FButton0};
    __property bool Button1={read=FButton1};
    __property bool Button2={read=FButton2};
    __property bool Button3={read=FButton3};
    __property bool AutoCheck={read=FAutoCheck,write=SetAutoCheck};
    __property bool Active={read=FActive,write=SetActive};
  __published:
    __property DWORD BufferSize={read=FBufferSize,write=SetBufferSize,default=16};
    __property bool Buffered={read=FBuffered,write=SetBuffered,default=true};
    __property bool Exclusive={read=FExclusive,write=SetExclusive,default=true};
    __property bool Background={read=FBackground,write=SetBackground};

    __property TEventMouseButton OnButton0Down={read=FOnButton0Down,write=FOnButton0Down};
    __property TEventMouseButton OnButton0Up={read=FOnButton0Up,write=FOnButton0Up};
    __property TEventMouseButton OnButton1Down={read=FOnButton1Down,write=FOnButton1Down};
    __property TEventMouseButton OnButton1Up={read=FOnButton1Up,write=FOnButton1Up};
    __property TEventMouseButton OnButton2Down={read=FOnButton2Down,write=FOnButton2Down};
    __property TEventMouseButton OnButton2Up={read=FOnButton2Up,write=FOnButton2Up};
    __property TEventMouseButton OnButton3Down={read=FOnButton3Down,write=FOnButton3Down};
    __property TEventMouseButton OnButton3Up={read=FOnButton3Up,write=FOnButton3Up};
    __property TEventMouseMove OnMove={read=FOnMove,write=FOnMove};
    __property TNotifyEvent OnChange={read=FOnChange,write=FOnChange};
};

class TMouseCheckLoop: public TThread
{
  private:
    TBXIMouse *ptMouse;
    void __fastcall UpdateView();
    void __fastcall Stop();

  protected:
    virtual void __fastcall Execute(void);
  public:
    bool Term;
    void __fastcall UpdateParam();
    __fastcall TMouseCheckLoop(TBXIMouse *);
    __fastcall ~TMouseCheckLoop();
};

#endif


